import { store, base_context } from 'https://unpkg.com/@startinblox/core@0.9/dist/libs/store/store.js';
const sibAuth = document.querySelector('sib-auth');

//We create a custom element
class CoopStarterLoginComponent extends HTMLElement {

  // Those function will be call the element is connected to the dom
  async connectedCallback() {
    document.getElementById("mentor_login").onclick = () => this.triggerLogin();
    this.update();
  }

  async triggerLogin() {
    let loader = document.getElementById('main-loader');
    loader.removeAttribute('hidden');
    await sibAuth.login();
  }

  decodeId(id) {
    let slashReplace = '~_';
    let colonReplace = '~@';
    let dotReplace = '~!';
    let tildeReplace = '~~';
    if (!id) return '';
    return id.replace(new RegExp(`\\${colonReplace}`, 'g'), ':')
      .replace(new RegExp(`\\${slashReplace}`, 'g'), '/')
      .replace(new RegExp(`\\${dotReplace}`, 'g'), '.')
      .replace(new RegExp(`\\${tildeReplace}`, 'g'), '~')
      .replace(/^@/, '');
  }

  
  async update() {
    let loader = document.getElementById('main-loader');
    loader.removeAttribute('hidden');
    let user = await sibAuth.getUser();

    console.log(user);
    //Set a userprefix default status
    var userPrefix = "public"
    
    // Idenfify the space we should go
    if (user) {
      await store.initGraph(user['@id'], base_context);
      user = await store.get(user['@id']);
      // if (!user)
      // user = await store.get(user);
      console.log(user);
      
      //If the user is a mentor or an entreprenur, change user prefix
      if(user && await user.mentor_profile) {
          console.log(user);
          userPrefix = "mentor"
      } else if (user && await user.entrepreneur_profile) {
          userPrefix = "entrepreneur"
      }
    }

    //If the url asked pointed to a resource
    if (window.location.href.indexOf('resource-detail') > -1) {
      var newUrl = window.location.href.replace(/\/([a-z]+)-dashboard\/([a-z]+)-resource-detail/, `/${userPrefix}-dashboard/${userPrefix}-resource-detail`)

      //If the url is different after the treatment, we reload with the good url
      if(newUrl !== window.location.href){
        var newRoute = new URL(newUrl).pathname.replace(/^\/([a-z]{2})\//, "")

        window.dispatchEvent(
          new CustomEvent('requestNavigation', { 
            detail: {
              route: 'entrepreneur-resource-detail',
              resource: { "@id": this.decodeId(newRoute.split(/@(.+)/)[1]) }
            }
          })
        );
      } else {
        loader.toggleAttribute('hidden', true);
      }
    } else {
      //User is a mentor
      if (userPrefix === "mentor") {
        window.dispatchEvent(
            new CustomEvent('requestNavigation', { detail: { route: 'mentor-dashboard' } })
          );
      //User is a entrepreneur
      } else if (userPrefix === "entrepreneur") {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'entrepreneur-dashboard' } })
        );
      } else if(user) {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'account-creation' } })
        );
      } else {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'splash' } })
        );
      }
    }
  }
  empty(){}
  populate(){}
}
customElements.define('cs-login', CoopStarterLoginComponent);